<template>
  <div id="app">
    <img alt="Vue logo" src="./assets/logo.png" width="100px">
    <h1>{{disciplina}}</h1>
    <div class="content">
      <div class="mainContent">
        <h3>Cálculo em tempo real</h3>
        <label>Salário Bruto:</label>
        <input type="number" @change="validarSalarioBruto($event)" id="inputSalarioBruto">

        <label>Base INSS:</label>
        <input v-model="baseCalculoINSS" type="number" id="inputBaseINSS" disabled="true">

        <label>Desconto INSS:</label>
        <input v-model="descontoINSS" type="number" id="inputDescontoINSS" disabled="true">

        <label>Base IRPF:</label>
        <input v-model="baseCalculoIRRF" type="number" id="inputBaseIRRF" disabled="true">

        <label>Desconto IRPF:</label>
        <input v-model="descontoIRRF" type="number" id="inputDescontoIRRF" disabled="true">

        <label>Salário líquido:</label>
        <input :value="calcSalarioLiquido" type="number" id="inputSalarioLiquido" disabled="true">
      </div>
      <div class="sideContent">
        <h3>Cálculo reverso com Observables</h3>

        <label>Salário líquido desejado:</label>
        <input :value="salarioLiquidoDesejado" type="number" id="inputSalarioLiquidoDesejado">

        <button @click="calcSalarioLiquidoDesejado">Calcular salário bruto correspondente</button>
      </div>
    </div>
  </div>
</template>

<script>

export default {
  name: "app",
  data() {
    return {
      disciplina: "Desenvolvimento Reativo",
      salarioBruto: 0,
      salarioLiquido: 0,
      baseINSS: 0,
      descontoINSS: 0,
      baseIRRF: 0,
      descontoIRRF: 0,
      salarioLiquidoDesejado: 0
    };
  },
  computed: {
    baseCalculoINSS() {
      return this.baseINSS = this.salarioBruto;
    },
    baseCalculoIRRF() {
      this.descontoINSS = this.calcDescontoINSS();
      this.baseIRRF = this.salarioBruto - this.descontoINSS;
      this.descontoIRRF = this.calcDescontoIRRF();
      return Number(this.baseIRRF).toFixed(2);
    },
    calcSalarioLiquido() {
      this.salarioLiquido =
        this.salarioBruto - this.descontoINSS - this.descontoIRRF;
      return Number(this.salarioLiquido).toFixed(2);
    }
  },
  methods: {
    formatValue() {
      return Number(this.value).toLocaleString("pt-BR", {
        style: "currency",
        currency: "BRL"
      });
    },
    calcDescontoINSS() {
      const TETO_INSS_2019 = 642.34;
      const tabelaINSS_2019 = [
        {
          ate: 1751.81,
          aliquota: 8
        },
        {
          ate: 2919.72,
          aliquota: 9
        },
        {
          ate: 5645.8,
          aliquota: 11
        },
        {
          ate: Number.MAX_SAFE_INTEGER,
          aliquota: 11
        }
      ];
      for (let item of tabelaINSS_2019) {
        if (this.baseINSS <= item.ate) {
          //console.log("BASE INSS " + this.baseINSS);
          this.descontoINSS = Math.min(
            this.baseINSS * (item.aliquota / 100),
            TETO_INSS_2019
          );
          break;
        }
      }
      //console.log("DESCONTO INSS " + this.descontoINSS);
      return Number(this.descontoINSS).toFixed(2);
    },
    calcDescontoIRRF() {
      //let this.descontoIRPF = 0;
      this.baseIRRF = parseInt(this.baseIRRF);

      const tabelaIRPF_2019 = [
        {
          ate: 1903.98,
          aliquota: 0,
          deducao: 0
        },
        {
          ate: 2826.65,
          aliquota: 7.5,
          deducao: 142.8
        },
        {
          ate: 3751.05,
          aliquota: 15.0,
          deducao: 354.8
        },
        {
          ate: 4664.68,
          aliquota: 22.5,
          deducao: 636.13
        },
        {
          ate: Number.MAX_SAFE_INTEGER,
          aliquota: 27.5,
          deducao: 869.36
        }
      ];

      for (let item of tabelaIRPF_2019) {
        //console.log("BASE IRRF " + this.baseIRRF);

        if (this.baseIRRF <= item.ate) {
          this.descontoIRRF = this.baseIRRF * (item.aliquota / 100);

          //console.log("DESCONTO IRRF " + this.descontoIRRF);
          //Aplicando a dedução
          this.descontoIRRF -= item.deducao;
          break;
        }
      }
      return Number(this.descontoIRRF).toFixed(2);
    },
    validarSalarioBruto(event) {
      this.salarioBruto = parseInt(event.target.value);
      //console.log(this.salarioBruto)

      if (
        this.salarioBruto === undefined ||
        typeof this.salarioBruto !== "number" ||
        this.salarioBruto < 0
      ) {
        throw new Error(
          "O parâmetro do salário bruto " +
            "é obrigatório e deve ser um " +
            "valor do tipo number maior ou igual a 0!"
        );
      }
      return Number(this.salarioBruto.toFixed(2)).toLocaleString("pt-br");
      //return Number(this.salarioBruto).toFixed(2);
    },
    calcSalarioLiquidoDesejado() {
      let increment = 0;
      let currentValue = 0;
      let difference = 0;
      //this.salarioBruto = 0;
      this.salarioLiquidoDesejado = this.$el.querySelector("#inputSalarioLiquidoDesejado").value;      
      console.log('salarioLiquido ' + this.salarioLiquido+' salarioLiquidoDesejado '+this.salarioLiquidoDesejado)

      if(this.salarioLiquido < this.salarioLiquidoDesejado){
      let temporizador = setInterval(() => {
        currentValue = this.salarioLiquido;

        difference = Math.abs(currentValue - +this.salarioLiquidoDesejado);
        increment = difference >= 5 ? 1 : 0.01;
        this.salarioBruto = inputSalarioBruto.value;
        inputSalarioBruto.value = (+inputSalarioBruto.value + increment).toFixed(2);
        console.log('difference '+difference)
        console.log('salarioLiquido ' + this.salarioLiquido+' - salarioLiquidoDesejado '+this.salarioLiquidoDesejado)

        if (this.salarioLiquido == this.salarioLiquidoDesejado)
          clearInterval(temporizador);
      }, 1);
      }
    }
  }
};
</script>

<style>
#app {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 10px;
}
body {
  font-family: Arial, Helvetica, sans-serif;
}

input,
span {
  display: block;
  width: 100%;
  font-size: 1.2em;
}

input {
  margin-bottom: 10px;
}
.row {
  display: flex;
  align-items: center;
  justify-content: flex-start;
  margin: 0 auto;
}

.content {
  display: flex;
  flex-direction: row;
  justify-content: flex-start;
  text-align: justify;
}

.mainContent {
  border: 1px solid gray;
  padding: 10px;
  margin-right: 30px;
  width: 50%;
}

.sideContent {
  border: 1px solid gray;
  padding: 10px;
  margin-right: 30px;
  width: 50%;
}
</style>
